package com.smcic.api.neican.aspect;

import com.smcic.api.neican.service.impl.RoleAclModuleServiceImpl;
import com.smcic.core.advice.APIException;
import com.smcic.core.auth.HttpContextUtil;
import org.aspectj.lang.JoinPoint;
import org.aspectj.lang.Signature;
import org.aspectj.lang.annotation.Aspect;
import org.aspectj.lang.annotation.Before;
import org.aspectj.lang.annotation.Pointcut;
import org.aspectj.lang.reflect.MethodSignature;
import org.springframework.stereotype.Component;
import org.springframework.web.context.request.RequestContextHolder;
import org.springframework.web.context.request.ServletRequestAttributes;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import java.lang.reflect.Method;

@Aspect
@Component
public class AclAspect {

    @Resource
    private RoleAclModuleServiceImpl roleAclModuleService;

    @Pointcut("execution(* com.smcic.api.neican.controller.*Controller.*(..))")
    public void logPointCut(){}

    /** 前置通知 */
    @Before("logPointCut()")
    public void before(JoinPoint joinPoint){
        HttpServletRequest request = ((ServletRequestAttributes) RequestContextHolder.getRequestAttributes()).getRequest();
        String path = request.getServletPath();

        if (path.contains("login") || path.contains("check")) {
            return;
        }
        String prefix = path.substring(0, path.replaceAll("\\/\\d+$", "").lastIndexOf("/"));

        if(HttpContextUtil.getToken().isPresent() && !roleAclModuleService.getCurrAllowPath().contains(prefix)){
            throw new APIException("没有权限");
        }

    }
}
